SystemOrganization addCategory: #'TP2-Parte5'!
SystemOrganization addCategory: #'TP2-Parte5-TestArea'!

Object subclass: #ClaseA
	instanceVariableNames: 'varAdeA varBdeA varCdeA'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5-TestArea'!

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varAdeA
	^ varAdeA! !

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varAdeA: anObject
	varAdeA := anObject! !

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varBdeA
	^ varBdeA! !

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varBdeA: anObject
	varBdeA := anObject! !

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varCdeA
	^ varCdeA! !

!ClaseA methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varCdeA: anObject
	varCdeA := anObject! !

Object subclass: #ClaseB
	instanceVariableNames: 'varAdeB varBdeB varCdeB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5-TestArea'!

!ClaseB methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 18:29'!
suma2: unValor mas: otroValor
	^unValor + otroValor. 
! !

!ClaseB methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 18:28'!
sumaTodo
	^varAdeB + varBdeB + varCdeB.
! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varAdeB
	^ varAdeB! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varAdeB: anObject
	varAdeB := anObject! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varBdeB
	^ varBdeB! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varBdeB: anObject
	varBdeB := anObject! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varCdeB
	^ varCdeB! !

!ClaseB methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:15'!
varCdeB: anObject
	varCdeB := anObject! !

ClaseB subclass: #ClaseB1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5-TestArea'!

ClaseB subclass: #ClaseB2
	instanceVariableNames: 'varAdeB2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5-TestArea'!

!ClaseB2 methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varAdeB2
	^ varAdeB2! !

!ClaseB2 methodsFor: 'accessing' stamp: 'CarlosManoja 5/1/2013 20:14'!
varAdeB2: anObject
	varAdeB2 := anObject! !

Object subclass: #TransformaATrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5'!

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 02:55'!
agregarAtributosDe: unTipo aLaClase: unaClase 

	unTipo instVarNames do: [ :unAtributo| unaClase addInstVarNamed: unAtributo].
! !

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 18:33'!
agregarMetodosDe: unTipo aLaClase: unaClase queSeanAccesors: esaEsLaCuestion

	|newSourceCode isAccesor|
	isAccesor := false.
	unTipo selectors do: [ :selector | 
		newSourceCode := (unTipo >> selector) sourceCode. 
		unTipo instVarNames do: [ :instVar | 
			1 ~= (newSourceCode indexOfSubCollection: instVar) 
				ifTrue:[newSourceCode := newSourceCode copyReplaceTokens: instVar with: 'self ',instVar.]
				ifFalse:[isAccesor := true.].
		].
		isAccesor = esaEsLaCuestion 
			ifTrue:[unaClase compile: newSourceCode.].
		isAccesor := false.
	].
! !

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 18:54'!
elAtributo: unAtributo delTipo: unTipo delaClase: unaClase

	| newTrait newSubTrait|
	
	newTrait := self esteTipo: unTipo. "Transforma una clase en Trait"
	
	self quitarAtributo: unAtributo deLaClase: unaClase. "Quita el atributo y los metodos que lo usen"

	self agregarAtributosDe: unTipo aLaClase: unaClase.
	self agregarMetodosDe: unTipo aLaClase: unaClase queSeanAccesors: true. "Pasa los Accesors a la clase"
	self agregarMetodosDe: unTipo aLaClase: newTrait queSeanAccesors: false. "Pasa el resto de los metodos al Trait"

	unTipo subclasses isEmptyOrNil not
		ifTrue: [unTipo subclasses do: [ :subclase| 
				newSubTrait := self esteTipo: subclase yQueUse: newTrait.
				self agregarAtributosDe: subclase aLaClase: unaClase.
				self agregarMetodosDe: subclase aLaClase: unaClase queSeanAccesors: true. "Pasa los Accesors a la clase"
				self agregarMetodosDe: subclase aLaClase: newSubTrait queSeanAccesors: false. "Pasa el resto de los metodos al Trait"
				].
		]. 

	unaClase superclass subclass: unaClase name 
		uses:  newTrait + (unaClase traitComposition)
		instanceVariableNames:  (unaClase  instVarNames joinUsing: ' ')
		classVariableNames:  ''
		poolDictionaries:  (unaClase poolDictionaryNames joinUsing: ' ')
		category:  unaClase category asString.! !

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/2/2013 23:56'!
esteTipo: unTipo

	^self esteTipo: unTipo yQueUse: nil.! !

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 18:57'!
esteTipo: unTipo yQueUse: suPadre

|traitName|

traitName := unTipo name , #TraitVersion.
suPadre isNil 
	ifTrue: [Trait named: traitName	asSymbol uses: {} category: unTipo category.] 
	ifFalse: [Trait named: traitName asSymbol uses: suPadre category: unTipo category.].
	
^Smalltalk at: traitName asSymbol.! !

!TransformaATrait class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/2/2013 21:00'!
quitarAtributo: unAtributo deLaClase: unaClase 

	unaClase selectors do: [ :selector | 
		((unaClase >> selector) sourceCode includesSubString: unAtributo)
			ifTrue: [unaClase removeSelector: selector. ].		
		].
	unaClase removeInstVarNamed: unAtributo.! !

TestCase subclass: #TP2Parte5Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte5'!

!TP2Parte5Tests methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 19:41'!
setUp 
MetaUtil recreateCategory: 'TP2-Parte5-TestArea'.! !

!TP2Parte5Tests methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 5/3/2013 19:36'!
test25ComposicionATrait
	
	| laClaseA elTipoB elAtributoDeA|
	
	laClaseA := Smalltalk at: #ClaseA.
	elTipoB := Smalltalk at: #ClaseB.
	elAtributoDeA := 'varBdeA'.

	TransformaATrait elAtributo: elAtributoDeA 
					    delTipo: elTipoB 
					    delaClase: laClaseA.
	
	self assert: ((Smalltalk at: #ClaseA) instVarNames includes: 'varBdeA') not.! !
